/*-------------------------------------------------------------------
    All files in this archive are under the GNU GPL v3 license
   Copyright 2008-2009 Purdea Andrei purdeaandrei _at_ yahoo.com
---------------------------------------------------------------------
  
  hexdecoder.v
  
  Description: This module converts a 4-bit number into its
  hexadecimal representation on a 7 segment display.
  The outputs are in MSB->LSB order:
   6  5  4  3  2  1  0
   A  B  C  D  E  F  G
  
  Here i'm taking advantage of the right-associativeness of the
  trenary operator.

-------------------------------------------------------------------*/

module hexdecoder(i, o);
input [3:0] i;
output [6:0] o;

assign o = i == 'h0 ? 7'b1111110 :
           i == 'h1 ? 7'b0110000 :
           i == 'h2 ? 7'b1101101 :
           i == 'h3 ? 7'b1111001 :
           i == 'h4 ? 7'b0110011 :
           i == 'h5 ? 7'b1011011 :
           i == 'h6 ? 7'b1011111 :
           i == 'h7 ? 7'b1110000 :
           i == 'h8 ? 7'b1111111 :
           i == 'h9 ? 7'b1111011 :
           i == 'hA ? 7'b1110111 :
           i == 'hB ? 7'b0011111 :
           i == 'hC ? 7'b1001110 :
           i == 'hD ? 7'b0111101 :
           i == 'hE ? 7'b1001111 :
              /*'hF*/ 7'b1000111 ;

endmodule