/*-------------------------------------------------------------------
    All files in this archive are under the GNU GPL v3 license
   Copyright 2008-2009 Purdea Andrei purdeaandrei _at_ yahoo.com
---------------------------------------------------------------------
  
  top_0123.v
  
  Description: This is a toplevel test module for synthesis.
  It will either show 0123, or the same number on all screens which
  is input on the swithces from the board. (Depending on which line
  is uncommented)
  
  This is for testing the hexdecoder with the rest of the system.

-------------------------------------------------------------------*/
module top(clk, stclk, shclk, sout, sw, swst);
input clk;
output stclk, shclk, sout;
input [3:0] sw;
output [3:0] swst;

assign swst = sw;

wire [31:0] data;

genvar i;
generate
    for (i=0;i<4;i=i+1) begin : bla
        hexdecoder h0 (.i(i), .o(data[(i+1) * 8 - 1:i * 8 + 1]));
        // alternatively: hexdecoder h0 (.i(sw), .o(data[(i+1) * 8 - 1:i * 8 + 1]));
        assign data[i * 8] = 1;
    end
endgenerate


extdriver e (.clk50(clk), .stclk(stclk), .shclk(shclk), .sout(sout), 
   .data(data));


endmodule